/*
 * (C) Copyright 2003
 * Tait Electronics Limited, Christchurch, New Zealand
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA

 * A collection of structures, addresses, and values associated with
 * the Tait Electronics ASIF board. Based on the Motorola FADS/ADS stuff.
 *
 */

/* ------------------------------------------------------------------------- */

#ifndef _CONFIG_ASIF_H
#define _CONFIG_ASIF_H

/*
 * High Level Configuration Options
 * (easy to change)
 */
#include <mpc8xx_irq.h>

#undef DEBUG				/* general noisiness */
#undef ET_DEBUG				/* net debug */

#define CONFIG_MPC859T		1
#define CONFIG_ASIF		1
#define CONFIG_8xx_GCLK_FREQ	125000000L
#define CONFIG_SPIN3		1
#define CONFIG_IDENT_STRING	" Tait Electronics Ltd"
#define CONFIG_SILENT_CONSOLE	1
#define CONFIG_MENUPROMPT	""	/* an empty string */
#define CONFIG_PASSWORD_ACCESS 	1
#define CONFIG_PASSWORD_TIMEOUT	5
#define CONFIG_NETCONSOLE	1
#define CFG_CONSOLE_IS_IN_ENV	1



#if (!defined(CONFIG_SPIN1) && !defined(CONFIG_SPIN2) && !defined(CONFIG_SPIN3))
#error "Undefined build SPIN option"
#endif

/* 
 * Values specific for the initial testing of the Spin 1 ASIF 
 */

#define CONFIG_ETHADDR          00:0D:CA:01:03:FF	/* ethaddr */
#define CONFIG_OVERWRITE_ETHADDR_ONCE	1		/* one change allowed */
#define CONFIG_IPADDR           192.168.1.254		/* my ipaddr */
#define CONFIG_NETMASK		255.255.255.0		/* netmask */
#define CONFIG_HOSTNAME		"unset"			/* hostname */
#undef	CFG_AUTOLOAD					/* autoload */

#define CONFIG_BAUDRATE		57600			/* baudrate */
#define CONFIG_BOOTDELAY	1			/* autoboot after 5 seconds */
#undef	CONFIG_BOOTARGS
#define CONFIG_PREBOOT		"run serial gen_vars"
#define CONFIG_PRELOGIN		"run erase_keys"

#define	CONFIG_EXTRA_ENV_SETTINGS					\
	"nfsargs=setenv bootargs root=/dev/nfs rw nfsroot=$rootip:$rootpath\0"	\
	"jffargs=setenv bootargs root=/dev/mtdblock1 rootfstype=jffs2 rw\0"			\
	"addip=setenv bootargs $bootargs ip=$ipaddr:$serverip:$gatewayip:$netmask:$hostname:eth0:off panic=1\0"\
	"mtd=set bootargs $bootargs mtdparts=asif:64K(param),0x$js(jffs),256K(u-boot),-(kernel)\0"\
	"flash_nfs=run nfsargs addip mtd; bootm $kb\0"		\
	"flash_jff=run jffargs addip mtd; bootm $kb\0"		\
	"net_nfs=tftp 400000 $bootfile;run nfsargs addip mtd;bootm 400000\0" \
	"serial=set stdin serial;set stdout serial\0"	\
	"nc=set stdin nc;set stdout nc\0"		\
	"silent=1 \0"					\
	"gen_vars=eval js $flash - 110000;" 		\
	    "eval kb $flash - c00c0000;"		\
	    "eval ke $flash - c0000001;"		\
	    "eval kt $flash - c00bffd3;"		\
	    "eval fe $flash - c0100001\0"		\
	"do_fs="					\
	  "if tftp 100000 $jff_file; then "		\
	    "cp 40004000 40000 2000;"			\
	    "go 40004 100000 $filesize;"		\
	    "if iminfo 100000; then "			\
	      "erase 40010000 $fe;"			\
	      "eval temp $filesize - 40;"		\
	      "cp.b 100040 40010000 $temp;"		\
	      "reset; "					\
	    "fi; "					\
	  "fi \0"					\
	"do_k="						\
	  "if tftp 40000 $bootfile;then "		\
	    "if iminfo 40000; then "			\
	      "erase $kb $ke;"	                	\
	      "cp.b 40000 $kb $filesize;"		\
	      "reset; "					\
	    "fi; "					\
	  "else "					\
	    "reset; "					\
	  "fi \0"					\
	"asifload="					\
	  "if iminfo $kb; then "			\
	    "if itest.s *$kt -ne $bootfile; then "	\
	      "run do_k;"				\
	    "else "					\
	      "if itest *ff003bf0 -eq deadf001; then "	\
	        "run do_fs;"				\
	      "fi; "					\
	      "if fsload 40000 /usr/bin/tait1/version; then "	\
	        "if itest.s *40000 -ne $jff_file; then "\
		  "run do_fs;"				\
		"else "					\
	           "if fsload 40000 /usr/bin/tait2/version; then "	\
	              "if itest.s *40000 -ne $jff_file; then "\
		         "run do_fs;"			\
		      "else "				\
		         "run flash_jff;"		\
	              "fi; "                            \
		   "else "                              \
		      "run do_fs;"                      \
		   "fi; "                               \
		"fi; "					\
	      "else "					\
	        "run do_fs;"				\
	      "fi; "					\
	    "fi; "					\
	  "else "					\
	    "run do_k;"					\
	  "fi \0"					\
	  "erase_keys="                                 \
	    "protect off 40008000 4000BFFF;"            \
	    "erase 40008000 4000BFFF;"                  \
	    "protect on 40008000 4000BFFF \0"           \
	  "password="                                   \
	    "$1$t1$I1/esE7KKBDIlNKqPsRW2/\0"            \
	""

/*	
	"bootcmd=run asifload\0"			\
	"serverip=172.25.140.8\0"			\
	"gatewayip=172.25.2.251\0"			\
	"jff_file=QBA20ASA001308\0"			\
	"bootfile=QBA20ASK001201\0"			\
	"rootpath=/home/manager/Users/default/root\0"	\
	"rootip=172.25.140.8\0"				\
	""
*/

#define CONFIG_BOOTCOMMAND	"run flash_jff"





#define CONFIG_8xx_CONS_SMC1	1	/* Console is on SMC1	    */
#undef	CONFIG_8xx_CONS_SMC2
#undef	CONFIG_8xx_CONS_NONE
#define CFG_DEVICE_NULLDEV	1

#define CONFIG_FEC_ENET		1
#define CONFIG_PHY_ADDR		0x01

#undef CONFIG_HARD_I2C			/* I2C with hardware support */

#define CFG_I2C_SPEED		93000	/* I2C speed */
#define CFG_I2C_SLAVE		0xFE	/* LSB must be clear!! */

#define	CONFIG_SOFT_I2C		1	/* I2C bit-banged		*/


#if defined(CONFIG_SOFT_I2C)
/*
 * Software (bit-bang) I2C driver configuration
 */
#define PB_SCL		0x00000020	/* PB 26 */
#define PB_SDA		0x00000010	/* PB 27 */

#define I2C_INIT	(immr->im_cpm.cp_pbdir |=  PB_SCL)
#define I2C_ACTIVE	(immr->im_cpm.cp_pbdir |=  PB_SDA)
#define I2C_TRISTATE	(immr->im_cpm.cp_pbdir &= ~PB_SDA)
#define I2C_READ	((immr->im_cpm.cp_pbdat & PB_SDA) != 0)
#define I2C_SDA(bit)	if(bit) immr->im_cpm.cp_pbdat |=  PB_SDA; \
			else    immr->im_cpm.cp_pbdat &= ~PB_SDA
#define I2C_SCL(bit)	if(bit) immr->im_cpm.cp_pbdat |=  PB_SCL; \
			else    immr->im_cpm.cp_pbdat &= ~PB_SCL
#define I2C_DELAY	udelay(2)	/* 1/4 I2C clock duration */

#elif defined(CONFIG_HARD_I2C)
#define CFG_I2C_UCODE_PATCH	1
#define CFG_I2C_DPMEM_OFFSET	0x1fc0

#endif	/* CONFIG_SOFT_I2C */




#define MPC8XX_XIN		40000000L	/* 40 MHz input frequency	*/


/* various DPLL factors to get correct clock speed of 125MHz */
#if CONFIG_SPIN1 || CONFIG_SPIN2		/* 40MHz clock */
#define MFI_FACT                6
#define MFD_FACT                3
#define MFN_FACT                1
#define S_FACT                  0
#define PDF_FACT                1
#endif

#if CONFIG_SPIN3		/* 13MHz clock */
#define MFI_FACT                9
#define MFD_FACT                12
#define MFN_FACT                8
#define S_FACT                  0
#define PDF_FACT                0
#endif


#define CONFIG_STATUS_LED	1	/* disco lights... */

#define	CONFIG_WATCHDOG		1	/* watchdog disabled	*/

#define CONFIG_BOOTP_MASK   (CONFIG_BOOTP_DEFAULT | CONFIG_BOOTP_BOOTFILESIZE)

/* POST support */
#define CONFIG_POST		(CFG_POST_CACHE	   | \
				 CFG_POST_MEMORY   | \
				 CFG_POST_CPU	   | \
				 CFG_POST_UART	   | \
				 CFG_POST_FEC      | \
				 CFG_POST_DIGIN    | \
				 CFG_POST_DIGOUT   | \
				 CFG_POST_I2C	   | \
				 CFG_POST_SPR)	   

/* 				 CFG_POST_WATCHDOG | \ */

#undef CFG_POST_INTERNAL_LOOP	/* all UART loopbacks are external */

#define CONFIG_LOGBUFFER	1

	/* 
	 * offset into DP_RAM we save the boot flag at
	 */
#define CONFIG_SHOW_BOOT_PROGRESS	1
#define CFG_CPM_POST_WORD_ADDR		0x1BFC		
#define CFG_CPM_MAGIC_WORD_ADDR		0x1bf4
#define CFG_CPM_PROGRESS_WORD_ADDR	0x1bf0
#define CFG_CPM_LAST_RESET_ADDR		0x1bec


/* List of I2C addresses to be verified by POST */
/* NOTE - addresses will be shifted left by 1 as LSB = R/W bit */
#define CFG_I2C_CODEC_ADDR	0x71	/* CODEC address on I2C bus */
#define CFG_I2C_EEPROM_ADDR	0x50	/* EEPROM address on I2C bus */
#define CFG_DEF_EEPROM_ADDR	CFG_I2C_EEPROM_ADDR

#define I2C_ADDR_LIST	{	CFG_I2C_CODEC_ADDR+0,	\
/* EEPROM - on 8 consecutive device select codes */	\
				CFG_I2C_EEPROM_ADDR+0,	\
				CFG_I2C_EEPROM_ADDR+1,	\
				CFG_I2C_EEPROM_ADDR+2,	\
				CFG_I2C_EEPROM_ADDR+3,	\
				CFG_I2C_EEPROM_ADDR+4,	\
				CFG_I2C_EEPROM_ADDR+5,	\
				CFG_I2C_EEPROM_ADDR+6,	\
				CFG_I2C_EEPROM_ADDR+7	\
			}


#define CFG_EEPROM_PAGE_WRITE_BITS 4	/* up to 16 bytes in a page write */
#define CFG_I2C_EEPROM_ADDR_LEN 1	/* 8 bit address */
/* mask of address bits that overflow into the "EEPROM chip address"    */
#define CFG_I2C_EEPROM_ADDR_OVERFLOW	0x07
#define CFG_EEPROM_PAGE_WRITE_DELAY_MS	10	/* takes up to 10 msec */
#define CFG_EEPROM_SIZE 0x800		/* 2048 bytes long (16k bits) */

#define CFG_JFFS2_NUM_BANKS	1
#define CFG_JFFS2_FIRST_BANK	0
#define CFG_JFFS2_FIRST_SECTOR	0

	/* default command defs */
#define CONFIG_COMMANDS (   ( 	  CONFIG_CMD_DFL	\
				| CFG_CMD_CACHE		\
				| CFG_CMD_DIAG		\
				| CFG_CMD_EEPROM	\
				| CFG_CMD_JFFS2		\
				| CFG_CMD_I2C		\
				| CFG_CMD_MII		\
				| CFG_CMD_IMMAP 	\
				| CFG_CMD_PING		\
				| CFG_CMD_ITEST		\
				| CFG_CMD_EVAL		\
			    )				\
	                & 				\
			   ~(				\
				  CFG_CMD_FPGA 		\
				| CFG_CMD_SETGETDCR	\
			    )				\
			)

/* this must be included AFTER the definition of CONFIG_COMMANDS (if any) */
#include <cmd_confdefs.h>


/*
 * Miscellaneous configurable options
 */

#define CFG_HUSH_PARSER		1	/* shell like syntax in commands */
#define CFG_PROMPT_HUSH_PS2	"> "

#define	CFG_LONGHELP		1	/* undef to save memory	    */
#define CFG_PROMPT	    "=>"	/* Monitor Command Prompt   */
#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#define CFG_CBSIZE	    1024	/* Console I/O Buffer Size  */
#else
#define CFG_CBSIZE	    256		/* Console I/O Buffer Size  */
#endif
#define CFG_PBSIZE	    (CFG_CBSIZE+sizeof(CFG_PROMPT)+16) /* Print Buffer Size */
#define CFG_MAXARGS	    16		/* max number of command args	*/
#define CFG_BARGSIZE	    CFG_CBSIZE	/* Boot Argument Buffer Size	*/

#define CFG_MEMTEST_START   0x00002000	/* memtest works on end vectors */

#if CONFIG_SPIN1
#define CFG_MEMTEST_END	    0x00370000	/* ... start relocated u-boot in SDRAM */
#endif

#if CONFIG_SPIN2 || CONFIG_SPIN3
#define CFG_MEMTEST_END	    0x03F60000	/* ... start relocated u-boot in SDRAM */
#endif

#define CFG_LOAD_ADDR	    0x00100000

#define CFG_HZ		    1000	/* decrementer freq: 1 ms ticks */

#define CFG_BAUDRATE_TABLE  { 9600, 19200, 38400, 57600, 115200 }

/*
 * Low Level Configuration Settings
 * (address mappings, register initial values, etc.)
 * You should know what you are doing if you make changes here.
 */
/*-----------------------------------------------------------------------
 * Internal Memory Mapped Register
 */
#define CFG_IMMR		0xFF000000
#define CFG_IMMR_SIZE		((uint)(64 * 1024))

/*-----------------------------------------------------------------------
 * Definitions for initial stack pointer and data area (in DPRAM)
 */
#define CFG_INIT_RAM_ADDR	CFG_IMMR
#define CFG_INIT_RAM_END	0x2F00	/* End of used area in DPRAM	*/
#define CFG_GBL_DATA_SIZE	64  /* size in bytes reserved for initial data */
#define CFG_GBL_DATA_OFFSET	(CFG_INIT_RAM_END - CFG_GBL_DATA_SIZE)
#define CFG_INIT_SP_OFFSET	CFG_GBL_DATA_OFFSET




/*-----------------------------------------------------------------------
 * Start addresses for the final memory configuration
 * (Set up by the startup code)
 * Please note that CFG_SDRAM_BASE _must_ start at 0
 */
#define CFG_SDRAM_BASE		0x00000000
#define CFG_FLASH_BASE		0x40000000
#define CFG_DSPHPI_BASE		0x80000000


#define CFG_MONITOR_LEN		(256 << 10) 	/* Reserve 256 kB for Monitor	*/
#define CFG_MONITOR_OFFSET	0x00100000	/* how far down the flash the monitor it */
#define CFG_MONITOR_BASE	(CFG_FLASH_BASE + FLASH_MAX_SIZE - CFG_MONITOR_OFFSET)	/* 1M down from end */
#define CFG_MALLOC_LEN		(384 << 10) 	/* Reserve 384 kB for malloc()	*/
#define CFG_RESET_ADDRESS	(CFG_FLASH_BASE - 4)	/* where we can guarantee a Machine Check */

/*
 * For booting Linux, the board info and command line data
 * have to be in the first 8 MB of memory, since this is
 * the maximum mapped by the Linux kernel during initialization.
 */
#define CFG_BOOTMAPSZ	    (8 << 20)	/* Initial Memory map for Linux */
/*-----------------------------------------------------------------------
 * FLASH organization
 */
#define CFG_MAX_FLASH_BANKS	1	/* max number of memory banks	    */
#define CFG_MAX_FLASH_SECT	144	/* max number of sectors on one chip	*/
#define CFG_FLASH_PROTECTION	1	/* enable lock/unlock code */

#define CFG_FLASH_ERASE_TOUT	120000	/* Timeout for Flash Erase (in ms)  */
#define CFG_FLASH_WRITE_TOUT	500	/* Timeout for Flash Write (in ms)  */
#define CFG_DIRECT_FLASH_TFTP	1

#undef	CFG_ENV_IS_IN_NVRAM
#undef	CFG_ENV_IS_IN_EEPROM	
#define	CFG_ENV_IS_IN_FLASH	1
#undef  CFG_ENV_IS_NOWHERE		

#define CFG_ENV_ADDR		CFG_FLASH_BASE	/* environment at start of flash */
/* keep older hardware compatible */
#if CONFIG_SPIN1
#define CFG_ENV_SIZE		0x600		/* Total Size of Environment Sector */
#endif
#if CONFIG_SPIN2 || CONFIG_SPIN3
#define CFG_ENV_SIZE		0x2000		/* Total Size of Environment Sector */
#endif
#define CFG_ENV_SECT_SIZE	0x2000		/* see README - env sector total size	*/

/* Address and size of Redundant Environment Sector	*/
#define CFG_ENV_ADDR_REDUND	(CFG_ENV_ADDR+CFG_ENV_SIZE)
#define CFG_ENV_SIZE_REDUND	(CFG_ENV_SIZE)


/*-----------------------------------------------------------------------
 * Cache Configuration
 */
#define CFG_CACHELINE_SIZE  16		/* For all MPC8xx CPUs		*/
#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#define CFG_CACHELINE_SHIFT 4		/* log base 2 of the above value    */
#endif

/*-----------------------------------------------------------------------
 * SYPCR - System Protection Control			11-9
 * SYPCR can only be written once after reset!
 *-----------------------------------------------------------------------
 * Software & Bus Monitor Timer max, Bus Monitor enable, SW Watchdog freeze
 */
#if defined(CONFIG_WATCHDOG)
#define CFG_SYPCR   (SYPCR_SWTC | SYPCR_BMT | SYPCR_BME | SYPCR_SWF | \
	     SYPCR_SWE | SYPCR_SWRI | SYPCR_SWP)
#else
#define CFG_SYPCR   (SYPCR_SWTC | SYPCR_BMT | SYPCR_BME | SYPCR_SWF | SYPCR_SWP)
#endif

/*-----------------------------------------------------------------------
 * SUMCR - SIU Module Configuration		    11-6
 *-----------------------------------------------------------------------
 * PCMCIA config., multi-function pin tri-state
 */
#define CFG_SIUMCR  (SIUMCR_DBGC00 | SIUMCR_DBPC00 | SIUMCR_MLRC01)

/*-----------------------------------------------------------------------
 * TBSCR - Time Base Status and Control			11-26
 *-----------------------------------------------------------------------
 * Clear Reference Interrupt Status, Timebase freezing enabled
 */
#define CFG_TBSCR   (TBSCR_REFA | TBSCR_REFB | TBSCR_TBE)

/*-----------------------------------------------------------------------
 * PISCR - Periodic Interrupt Status and Control	11-31
 *-----------------------------------------------------------------------
 * Clear Periodic Interrupt Status, Interrupt Timer freezing enabled
 */
#define CFG_PISCR   (PISCR_PS | PISCR_PITF)

/*-----------------------------------------------------------------------
 * PLPRCR - PLL, Low-Power, and Reset Control Register	15-30
 *-----------------------------------------------------------------------
 * set the PLL, the low-power modes and the reset control (15-29)
 */
#define CFG_PLPRCR  ((MFN_FACT << 27) |	(MFD_FACT << 22) | (S_FACT << 20) | \
                (MFI_FACT << 16) | (PDF_FACT << 1) | PLPRCR_TEXPS)


/*-----------------------------------------------------------------------
 * SCCR - System Clock and reset Control Register	15-27
 *-----------------------------------------------------------------------
 * Set clock output, timebase and RTC source and divider,
 * power management and some other internal clocks
 */
#define SCCR_MASK   SCCR_EBDF11
#define CFG_SCCR    (SCCR_TBS | SCCR_COM00 | SCCR_DFSYNC00 | \
		   SCCR_DFBRG00 | SCCR_DFNL100 | SCCR_DFNH000 | \
		   SCCR_DFLCD000 | SCCR_DFALCD10)


 /*-----------------------------------------------------------------------
 *
 *-----------------------------------------------------------------------
 *
 */
#define CFG_DER	    0

/* Because of the way the 860 starts up and assigns CS0 the
* entire address space, we have to set the memory controller
* differently.	Normally, you write the option register
* first, and then enable the chip select by writing the
* base register.  For CS0, you must write the base register
* first, followed by the option register.
*/

/*
 * Init Memory Controller:
 *
 * BR0 and OR0 (FLASH)
 */

#define FLASH_BASE0_PRELIM	CFG_FLASH_BASE	/* FLASH bank #0 */
#define	FLASH_MAX_SIZE		0x00800000	/* max 8M total	*/

/* FLASH timing: ACS = 10, TRLX = 1, CSNT = 1, SCY = 3, EHTR = 0    */
#define CFG_OR_TIMING_FLASH (OR_CSNT_SAM  | OR_ACS_DIV4 | OR_BI | OR_SCY_3_CLK | OR_TRLX)


/*
 * BR1 and OR1 (SDRAM)
 *
 */
#define SDRAM_BASE1_PRELIM	CFG_SDRAM_BASE	/* SDRAM bank #0	*/
#define	SDRAM_MAX_SIZE		0x10000000	/* max 256M total	*/

/* SDRAM timing: Multiplexed addresses, GPL5 output to GPL5_A (don't care)	*/
#define CFG_OR_TIMING_SDRAM (OR_CSNT_SAM  | OR_G5LS)


/*
 * BR2 and OR2 (DSP HPI)
 *
 */

#define DSPHPI_BASE2_PRELIM	CFG_DSPHPI_BASE	/* base address */
#define DSPHPI_MAX_SIZE		0x00400000	/* 256Kwords plus extra address lines for control regs */

/* DSP HPI timing: CSNT = 1, ACS = 10, BIH = 1, SCY = 15, EHTR = 1,  TRLX = 1   */
#if CONFIG_SPIN1 || CONFIG_SPIN2
#define CFG_OR_TIMING_DSPHPI (OR_CSNT_SAM  | OR_ACS_DIV4 | OR_BI | OR_SCY_15_CLK | OR_EHTR | OR_TRLX)
#endif

#if CONFIG_SPIN3
#define CFG_OR_TIMING_DSPHPI (OR_CSNT_SAM  | OR_ACS_DIV4 | OR_BI | OR_SCY_15_CLK | OR_SETA | OR_EHTR | OR_TRLX)
#endif



#ifdef USE_REAL_ORBR_VALUES
/*
 * These values SHOULD fit our ASIF
 * Not expected to use these values though...
 */
#define CFG_BR0_PRELIM	0x40000801	/* Real values for the board */
#define CFG_OR0_PRELIM	0xffc00d34
#define CFG_BR1_PRELIM	0x00000081	/* assume 8M SDRAM */
#define CFG_OR1_PRELIM	0xff800a00
#define CFG_BR2_DSPHPI	0x80000801
#define CFG_OR2_DSPHPI	0xffc00df6
#else

#define CFG_OR0_PRELIM	((-FLASH_MAX_SIZE  & OR_AM_MSK) | CFG_OR_TIMING_FLASH)   /* 1 Mbyte until detected and only 1 Mbyte is needed*/
#define CFG_BR0_PRELIM	((FLASH_BASE0_PRELIM & BR_BA_MSK) | BR_PS_16 | BR_V )
#define CFG_OR1_PRELIM	((-(SDRAM_MAX_SIZE * 2)  & OR_AM_MSK) | CFG_OR_TIMING_SDRAM )
#define CFG_BR1_PRELIM	((SDRAM_BASE1_PRELIM & BR_BA_MSK) | BR_MS_UPMA | BR_V )
#define CFG_OR2_DSPHPI	((-DSPHPI_MAX_SIZE & OR_AM_MSK) | CFG_OR_TIMING_DSPHPI)
#define CFG_BR2_DSPHPI	((DSPHPI_BASE2_PRELIM & BR_BA_MSK) | BR_PS_16 | BR_V )

#endif

/* lots of magic values used to check the dsp is OK & load code into it */
#define CFG_DSPHPI_START	0x00100000	/* where code offsets start from */
#define CFG_DSPHPI_LOAD		0x00100060 	/* offset 000c0 code bytes on DSP side */
#define CFG_DSPHPI_VECTOR	0x00108000
#define CFG_DSPHPI_CONTROL	0x00000000
#define CFG_DSPHPI_ADDR1	0x00110000
#define CFG_DSPHPI_CODE1	0x1111
#define CFG_DSPHPI_ADDR2	0x00120000
#define CFG_DSPHPI_CODE2	0x2222
#define CFG_DSPHPI_START_CODE	0x0001			/* magic number to start DSP */


#if CONFIG_SPIN1
#define CFG_DSPHPI_OFFSET	0x00100000 	/* in words!! - becomes 0x01 when h/w fixed */
#define CFG_DSPHPI_INC		2		/* becomes 1 when h/w fixed */
#define CFG_DSPHPI_VERSION	0x003000ee	/* hard coded odd address ?!? */
#endif

#if CONFIG_SPIN2 || CONFIG_SPIN3
#define CFG_DSPHPI_OFFSET	0x00000001
#define CFG_DSPHPI_INC		1
#define CFG_DSPHPI_VERSION	0x001000ef
#endif


/*
 * Memory Periodic Timer Prescaler
 *
 * The Divider for PTA (refresh timer) configuration is based on an
 * example SDRAM configuration (64 MBit, one bank). The adjustment to
 * the number of chip selects (NCS) and the actually needed refresh
 * rate is done by setting MPTPR.
 *
 * PTA is calculated from
 *	PTA = (gclk * Trefresh) / ((2 ^ (2 * DFBRG)) * PTP * NCS)
 *
 *	gclk	  CPU clock (not bus clock!)
 *	Trefresh  Refresh cycle * 4 (four word bursts used)
 *
 * 4096  Rows from SDRAM example configuration
 * 1000  factor s -> ms
 *   32  PTP (pre-divider from MPTPR) from SDRAM example configuration
 *    4  Number of refresh cycles per period
 *   64  Refresh cycle in ms per number of rows
 * --------------------------------------------
 * Divider = 4096 * 32 * 1000 / (4 * 64) = 512000
 *
 * 50 MHz => 50.000.000 / Divider =  98
 * 66 Mhz => 66.000.000 / Divider = 129
 * 80 Mhz => 80.000.000 / Divider = 156
 */
#if   defined(CONFIG_80MHz)
#define CFG_MAMR_PTA		156
#elif defined(CONFIG_66MHz)
#define CFG_MAMR_PTA		129
#else		/*   50 MHz */
#define CFG_MAMR_PTA		 98
#endif	/*CONFIG_??MHz */

/*
 * For 16 MBit, refresh rates could be 31.3 us
 * (= 64 ms / 2K = 125 / quad bursts).
 * For a simpler initialization, 15.6 us is used instead.
 *
 * #define CFG_MPTPR_2BK_2K	MPTPR_PTP_DIV32		for 2 banks
 * #define CFG_MPTPR_1BK_2K	MPTPR_PTP_DIV64		for 1 bank
 */
#define CFG_MPTPR_2BK_4K	MPTPR_PTP_DIV16		/* setting for 2 banks	*/
#define CFG_MPTPR_1BK_4K	MPTPR_PTP_DIV32		/* setting for 1 bank	*/

/* refresh rate 7.8 us (= 64 ms / 8K = 31.2 / quad bursts) for 256 MBit		*/
#define CFG_MPTPR_2BK_8K	MPTPR_PTP_DIV8		/* setting for 2 banks	*/
#define CFG_MPTPR_1BK_8K	MPTPR_PTP_DIV16		/* setting for 1 bank	*/

/*
 * MAMR settings for SDRAM
 */

/* 8 column SDRAM */
#define CFG_MAMR_8COL	((CFG_MAMR_PTA << MAMR_PTA_SHIFT)  | MAMR_PTAE	    |	\
			 MAMR_AMA_TYPE_0 | MAMR_DSA_1_CYCL | MAMR_G0CLA_A11 |	\
			 MAMR_RLFA_1X	 | MAMR_WLFA_1X	   | MAMR_TLFA_4X)

/* 9 column SDRAM */
#define CFG_MAMR_9COL	((CFG_MAMR_PTA << MAMR_PTA_SHIFT)  | MAMR_PTAE	    |	\
			 MAMR_AMA_TYPE_1 | MAMR_DSA_1_CYCL | MAMR_G0CLA_A10 |	\
			 MAMR_RLFA_1X	 | MAMR_WLFA_1X	   | MAMR_TLFA_4X)

/* 10 column SDRAM */
#define CFG_MAMR_10COL	((CFG_MAMR_PTA << MAMR_PTA_SHIFT)  | MAMR_PTAE	    |	\
			 MAMR_AMA_TYPE_2 | MAMR_DSA_1_CYCL | MAMR_G0CLA_A12 |	\
			 MAMR_RLFA_1X	 | MAMR_WLFA_1X	   | MAMR_TLFA_4X)


/*
 * Internal Definitions
 *
 * Boot Flags
 */
#define BOOTFLAG_COLD	0x01	    /* Normal Power-On: Boot from FLASH */
#define BOOTFLAG_WARM	0x02	    /* Software reboot		*/


#define FEC_INTERRUPT	SIU_LEVEL1  /* FEC interrupt */
#define CFG_DISCOVER_PHY	1


/*
 * General I/O definitions here please!!
 */

/* the digital outputs are on port B & C */
#define PB_DIGIO_MASK		0x0003ff00		/* PB 14 - 19, 22, 23 */
#define PC_DIGIO_MASK		0x00070000		/* PC 13 - PB 15 */

/* extra control lines on port A */
#define PA_TP201		((ushort)0x2000)	/* PA 2 */
#define PA_1PPS_INPUT		((ushort)0x1000)	/* PA 3  */
#define PA_DSP_RESET		((ushort)0x0004)	/* PA 13 */
#define PA_ASIF_NRDY		((ushort)0x0008)	/* PA 12 */



#endif	/* _CONFIG_ASIF_H */
